<script type="text/javascript">
    RED.nodes.registerType('mm-upload', {
        category: "mattermost",
        defaults: {
            name: { value: "Mattermost" },
            host: { value: "", type: "mm-config" },
            files: { value: "" },
            channel: { value: "" }
        },
        inputs: 1,
        outputs: 1,
        icon: "font-awesome/fa-cloud-upload",
        color: "#a6bbcf",
        label: function() {
            return (this.name || "mm-upload")
        }
    });

</script>

<script type="text/x-red" data-template-name="mm-upload">
    <div class="form-row">
        <label for="node-input-name"><i class="icon-tag"></i> Name</label>
        <input type="text" id="node-input-name" placeholder="Name">
    </div>
    <div class="form-row">
        <label for="node-input-host"><i class="icon-bookmark"></i> Host</label>
        <input type="text" id="node-input-host">
    </div>
    <div class="form-row">
        <label for="node-input-files"><i class="fa fa-files-o"></i> Files</label>
        <input type="text" id="node-input-files" placeholder="Files">
    </div>
    <div class="form-row">
        <label for="node-input-file"><i class="fa fa-users"></i> Channel</label>
        <input type="text" id="node-input-channel" placeholder="Channel">
    </div>

    <div class="form-tips"><b>Tip:</b> Multiple files can be uploaded by setting a comma-separated string.</div>
</script>

<script type="text/x-red" data-help-name="mm-upload">
    <p>
        Upload a file to a Mattermost channel
    </p>

    <h3>Inputs</h3>
        <dl class="message-properties">
            <dt class="optional">files
                <span class="property-type">array</span>
            </dt>
            <dd> an array of paths to files (strings) to upload.</dd>
            <dt class="optional">channel
                <span class="property-type">string</span>
            </dt>
           <dd> the Mattermost channel to publish to.</dd>
       </dl>

    <h3>Details</h3>
    <p>
        The path(s) to the file(s) you wish to upload can be configured in the node or, if left blank, can be set by <code>msg.files</code>.
    </p>
    <p>
        The channel used can be configured in the node or, if left blank, can be set by <code>msg.channel</code>.
        If both are omitted, the default channel set in the configuration node will be used.
    </p>
    <p>
        To send a DM, set the channel name to <code>@username</code>
    </p>

    <h3>Outputs</h3>
        <dl class="message-properties">
            <dt class="optional">payload
                <span class="property-type">object</span>
            </dt>
            <dd> the response given by the Mattermost API.</dd>
        </dl>
</script>
